<template>
  <div
    data-component-group="user-form"
    data-component="notifications"
  >
    <form
      v-if="!isDisabled"
      @:submit.prevent="onSubmit"
    >
      <v-layout>
        <v-flex xs12>
          <v-layout>
            <v-flex xs4>
              <v-autocomplete
                v-model="country"
                :items="countries"
                :filter="customFilter"
                prepend-inner-icon="public"
                label="Country"
                item-text="name"
                item-value="code"
                :return-object="true"
                required
                :readonly="isDisabled"
                :menu-props="{nudgeBottom:'10'}"
                :error-messages="countryErrors"
              />
            </v-flex>
            <v-flex xs4>
              <v-autocomplete
                v-model="assignmentType"
                :items="assignmentTypes"
                :filter="customFilter"
                prepend-inner-icon="public"
                label="Assignment"
                item-text="name"
                item-value="code"
                :return-object="true"
                required
                :readonly="isDisabled"
                :menu-props="{nudgeBottom:'10'}"
                :error-messages="assignmentTypeErrors"
              />
            </v-flex>
            <v-flex xs4>
              <v-autocomplete
                v-model="accountType"
                :items="accountTypes"
                :filter="customFilter"
                prepend-inner-icon="public"
                label="Account type"
                item-text="name"
                item-value="code"
                :return-object="true"
                required
                :readonly="isDisabled"
                :menu-props="{nudgeBottom:'10'}"
                :error-messages="accountTypeErrors"
              />
            </v-flex>
          </v-layout>
          <v-layout>
            <v-flex xs12>
              <v-autocomplete
                v-model="selectedCategories"
                :items="categories"
                :filter="customFilter"
                :multiple="true"
                :loading="isLoadingCategories"
                prepend-inner-icon="public"
                label="Category"
                item-text="name"
                item-value="code"
                :return-object="true"
                required
                :readonly="isDisabled"
                :menu-props="{nudgeBottom:'10'}"
                :error-messages="categoryErrors"
              />
            </v-flex>
          </v-layout>
        </v-flex>
        <v-flex class="flex-trigger">
          <div class="trigger-box">
            <v-btn
              icon
              class="trigger add-notifications"
              @click="addNotifications"
            >
              <v-icon>
                add
              </v-icon>
            </v-btn>
          </div>
        </v-flex>
      </v-layout>
    </form>

    <Removables
      :items="notifications"
      :is-disabled="isDisabled || !$ability.can('manage-notifications', 'user')"
      :on-remove="removeNotifications"
    >
      <template
        slot="item"
        slot-scope="scope"
      >
        <div class="removable-box">
          <div
            class="country"
            title="Country"
          >
            <div class="country-label">
              <v-icon>
                public
              </v-icon>
              {{ scope.item.country_notify.name }}
            </div>
          </div>
          <div
            class="assignment"
            title="Assignment"
          >
            {{ scope.item.assignment.name }}
          </div>
          <div
            class="account-type"
            title="Account type"
          >
            {{ scope.item.account_type.name }}
          </div>
        </div>
        <div
          class="category"
          title="Category"
        >
          {{ scope.item.category.map((c) => c.name).join(', ') }}
        </div>
      </template>
    </Removables>
  </div>
</template>

<script>
  import { validationMixin } from 'vuelidate';
  import { required } from 'vuelidate/lib/validators';
  import colors from 'vuetify/es5/util/colors';
  import Removables from '../../lists/Removables';
  import { isStr, isObj } from '../../../utils';

  // TODO: Translate component

  export default {
    components: {
      Removables
    },
    mixins: [validationMixin],
    validations() {
      return {
        country: {
          required
        },
        assignmentType: {
          required
        },
        accountType: {
          required
        },
        selectedCategories: {
          required
        }
      };
    },
    props: {
      user: {
        type: Object,
        required: true
      },
      isDisabled: {
        type: Boolean,
        default: false
      }
    },
    data() {
      return {
        country: {},
        assignmentType: {},
        accountType: {},
        selectedCategories: [],
        colors,
        notifications: [],
        isLoadingCategories: false,
        isUpdatingNotifications: false
      };
    },
    computed: {
      selectedCountry() {
        return this.$store.getters['config/country'];
      },
      countries() {
        return this.user.countries;
      },
      assignmentTypes() {
        return this.$store.getters['users/assignmentTypes'];
      },
      accountTypes() {
        return this.$store.getters['users/notificationTypes'];
      },
      categories() {
        return this.$store.getters['threads/categories'];
      },
      countryErrors() {
        const errors = [];
        if (!this.$v.country.$dirty) {
          return errors;
        }
        if (!this.$v.country.required) {
          errors.push('Country is required');
        }
        return errors;
      },
      assignmentTypeErrors() {
        const errors = [];
        if (!this.$v.assignmentType.$dirty) {
          return errors;
        }
        if (!this.$v.assignmentType.required) {
          errors.push('Assignment is required');
        }
        return errors;
      },
      accountTypeErrors() {
        const errors = [];
        if (!this.$v.accountType.$dirty) {
          return errors;
        }
        if (!this.$v.accountType.required) {
          errors.push('Account type is required');
        }
        return errors;
      },
      categoryErrors() {
        const errors = [];
        if (!this.$v.selectedCategories.$dirty) {
          return errors;
        }
        if (!this.$v.selectedCategories.required) {
          errors.push('Category is required');
        }
        return errors;
      }
    },
    watch: {
      user(nextUser) {
        if (isObj(nextUser)) {
          this.getCategories();

          if (this.$ability.can('get-notifications', 'user')) {
            this.getNotifications();
          }
        }
      }
    },
    created() {
      this.getCategories();

      if (this.$ability.can('get-notifications', 'user')) {
        this.getNotifications();
        this.getNotificationAccountTypes();
      }
    },
    methods: {
      getCategories() {
        const query = {
          target_country: this.selectedCountry.code
        };

        this.isLoadingCategories = true;
        return this.$store.dispatch('threads/getCategories', query)
          .then((res) => {
            this.isLoadingCategories = false;
            return res;
          })
          .catch((err) => {
            this.isLoadingCategories = false;
            return err;
          });
      },
      customFilter(item, queryText) {
        const textOne = item.name.toLowerCase();
        const searchText = queryText.toLowerCase();

        return textOne.indexOf(searchText) > -1;
      },
      getNotifications() {
        const query = {
          id: this.user.id
        };

        return this.$store.dispatch('users/getNotifications', query)
          .then((res) => {
            const { notifications } = this.$store.getters['users/activeItem'];
            this.notifications = notifications;
            return res;
          });
      },
      getNotificationAccountTypes() {
        return this.$store.dispatch('users/getNotificationAccountTypes');
      },
      addNotifications() {
        this.$v.$touch();

        if (!this.canSubmitRequest() || this.$v.$error || this.$v.pending) {
          return false;
        }

        const query = {
          id: this.user.id,
          country_notify: this.country.code,
          assignment: this.assignmentType.code,
          account_type: this.accountType.code,
          category: this.selectedCategories.map(({ code }) => code)
        };

        return this.$store.dispatch('users/addNotification', query)
          .then((res) => {
            const incomingNotification = res.data.data;
            const uniqueNotifications = this.notifications.filter((n) => n.country_notify.code !== incomingNotification.country_notify.code);
            this.notifications = [...uniqueNotifications, incomingNotification];

            return res;
          });
      },
      removeNotifications(notification) {
        const query = {
          id: this.user.id,
          country_notify: notification.country_notify.code
        };

        this.notifications = this.notifications.filter((n) => n.country_notify.code !== notification.country_notify.code);

        return this.$store.dispatch('users/removeNotification', query);
      },
      canSubmitRequest() {
        const { country, assignmentType, accountType, selectedCategories } = this;

        return isStr(country.code)
          && isStr(assignmentType.code)
          && isStr(accountType.code)
          && selectedCategories.length > 0;
      },
      clear() {
        this.$v.$reset();
        this.country = {};
        this.assignmentType = {};
        this.accountType = {};
        this.selectedCategories = [];
      }
    }
  };
</script>

<style lang="stylus" scoped>
  @import '../../../assets/stylus/theme.styl';

  [data-component-group="user-form"] {
    &[data-component="notifications"] {
      .trigger-box {
        display: flex;
        justify-content: center;
        align-items: center;
        width: 100%;
        height: calc(100% - 30px);
      }

      .trigger.add-notifications {
        width: 50px;
        height: 50px;
        border-radius: 50%;

        &:before {
          background-color: $colors.secondary;
        }
      }

      .removable-box {
        width: 100%;
        display: flex;
        justify-content: flex-start;
        align-items: center;

        .country {
          display: flex;
          flex-direction: column;
        }

        > div {
          display: flex;
          width: 33.33%;

          &.country {
            .v-icon {
              margin: 0 6px 0 0;
            }
          }
        }
      }

      .category {
        color: $colors.grey.base;
      }

      .flex-trigger {
        min-width: 80px;
      }
    }
  }
</style>
